///////////////////////////////////////////
//
//  This file is for bookkeeping tasks that
//  don't fall into the more focused analysis
//  categories.
//
///////////////////////////////////////////

#include <stdlib.h>
#include <stdio.h>
#include <assert.h>

#include "utility.hpp"
#include "outstreams.hpp"
#include "SC2Map.hpp"


void SC2Map::countPathableCells()
{
  for( int pci = 0; pci < cxDimPlayable; ++pci )
  {
    for( int pcj = 0; pcj < cyDimPlayable; ++pcj )
    {
      point c;
      c.pcSet( pci, pcj );

      if( getPathing( &c, PATH_GROUND_NOROCKS   ) ) { ++numPathableCells[PATH_GROUND_NOROCKS];   }
      if( getPathing( &c, PATH_GROUND_WITHROCKS ) ) { ++numPathableCells[PATH_GROUND_WITHROCKS]; }
      if( getPathing( &c, PATH_CWALK_NOROCKS    ) ) { ++numPathableCells[PATH_CWALK_NOROCKS];    }
      if( getPathing( &c, PATH_CWALK_WITHROCKS  ) ) { ++numPathableCells[PATH_CWALK_WITHROCKS];  }
      if( getPathing( &c, PATH_BUILDABLE        ) ) { ++numPathableCells[PATH_BUILDABLE];        }
    }
  }
}
